<?php
namespace T3\Dce\Utility;

/*  | This extension is made for TYPO3 CMS and is licensed
 *  | under GNU General Public License.
 *  |
 *  | (c) 2012-2019 Armin Vieweg <armin@v.ieweg.de>
 */
use TYPO3\CMS\Core\Core\Bootstrap;

/**
 * LanguageService utility
 */
class LanguageService
{
    /**
     * Initializes LanguageObject if necessary
     *
     * @return void
     */
    protected static function initialize() : void
    {
        Bootstrap::getInstance()->initializeBackendUser();
        Bootstrap::getInstance()->initializeLanguageObject();
    }

    /**
     * splitLabel function
     *
     * All translations are based on $LOCAL_LANG variables.
     * 'language-splitted' labels can therefore refer to a local-lang file + index.
     * Refer to 'Inside TYPO3' for more details
     *
     * @param string|null $input Label key/reference
     * @param bool $hsc If set, the return value is htmlspecialchar'ed
     * @return string
     */
    public static function sL(?string $input, bool $hsc = false) : string
    {
        if (!$input) {
            return '';
        }
        if (!$GLOBALS['LANG']) {
            static::initialize();
        }
        return $GLOBALS['LANG']->sL($input, $hsc);
    }
}
